Package org.optaplanner.core.impl.heuristic.selector.common.nearby

## Class LinearDistributionNearbyRandom

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.selector.common.nearby.LinearDistributionNearbyRandom

- All Implemented Interfaces:
    `NearbyRandom`

      public class LinearDistributionNearbyRandom
      extends Object
      implements NearbyRandom

  `P(x) = 2/m - 2x/m²`.

  Cumulative probability: `F(x) = x(2m - x)/m²`.

  Inverse cumulative probability: `F(p) = m(1 - (1 - p)^(1/2))`.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected int` | `sizeMaximum` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `LinearDistributionNearbyRandom​(int sizeMaximum)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `getOverallSizeMaximum()` | Used to limit the RAM memory size of the nearby distance matrix.
    `int` | `nextInt​(Random random, int nearbySize)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### sizeMaximum

          protected final int sizeMaximum

  - ### Constructor Detail

    - #### LinearDistributionNearbyRandom

          public LinearDistributionNearbyRandom​(int sizeMaximum)

  - ### Method Detail

    - #### nextInt

          public int nextInt​(Random random,
                             int nearbySize)

      Specified by:
        `nextInt` in interface `NearbyRandom`
      Parameters:
        `random` - never null
        `nearbySize` - never negative. The number of available values to select from. Normally this is the size of the value range for a non-chained variable and the size of the value range (= size of the entity list) minus 1 for a chained variable.
      Returns:
        `0 <= x < nearbySize`

    - #### getOverallSizeMaximum

          public int getOverallSizeMaximum()

      Description copied from interface: `NearbyRandom`
      Used to limit the RAM memory size of the nearby distance matrix.
      Specified by:
        `getOverallSizeMaximum` in interface `NearbyRandom`
      Returns:
        one more than the maximum number that `NearbyRandom.nextInt(Random, int)` can return, `Integer.MAX_VALUE` if there is none